Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankDuplicateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankDuplicateExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankDuplicateExpressions.cs	(revision 14513)
@@ -1,91 +1,127 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    /// <summary>
-    /// Pushes a copy of an indexed item "deep" in the stack onto the top of the stack, without removing the deep item.
-    /// The index is taken from the INTEGER stack, and the indexing is done after the index is removed.
-    /// </summary>
-    /// <typeparam name="T">Stacktype</typeparam>
-    public abstract class YankDuplicateExpression<T> : StatelessExpression
+  /// <summary>
+  ///     Pushes a copy of an indexed item "deep" in the stack onto the top of the stack, without removing the deep item.
+  ///     The index is taken from the INTEGER stack, and the indexing is done after the index is removed.
+  /// </summary>
+  /// <typeparam name="T">Stacktype</typeparam>
+  public abstract class YankDuplicateExpression<T> : StatelessExpression
+  {
+    public void Eval(IStack<T> stack, IStack<long> integerStack)
     {
-        public void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1)
-        {
-            if (integerStack.Count == 0)
-                return;
-
-            var index = integerStack.Top;
-
-            if (index > stack.Count - count ||
-                index < 0 ||
-                stack.Count < 2)
-                return;
-
-            integerStack.Pop();
-            var item = stack.ElementAt((int)index);
-
-            stack.Push(item);
-        }
+      T item;
+      if (this.TryGetItem(stack, integerStack, out item)) stack.Push(item);
     }
 
-    public class IntegerYankDuplicateExpression : YankDuplicateExpression<long>
+    public void Eval(IStack<Expression> stack, IStack<long> integerStack)
     {
-        protected override string InitStringRepresentation() { return "INTEGER.YANKDUP"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
-        }
+      Expression item;
+      if (this.TryGetItem(stack, integerStack, out item)) stack.Push(item);
     }
 
-    public class FloatYankDuplicateExpression : YankDuplicateExpression<double>
+    public void Eval(IStack<long> integerStack)
     {
-        protected override string InitStringRepresentation() { return "FLOAT.YANKDUP"; }
+      if ((integerStack.Count < 2) || (integerStack.Top > integerStack.Count - 2) || (integerStack.Top < 0)) return;
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.FloatStack, interpreter.IntegerStack);
-        }
+      var index = (int)integerStack.Pop();
+      var item = integerStack.ReverseElementAt(index);
+
+      integerStack.Push(item);
     }
 
-    public class BooleanYankDuplicateExpression : YankDuplicateExpression<bool>
+    private bool TryGetItem<E>(IStack<E> stack, IStack<long> integerStack, out E item)
     {
-        protected override string InitStringRepresentation() { return "BOOLEAN.YANKDUP"; }
+      if ((integerStack.Count == 0) || (integerStack.Top >= stack.Count) || (integerStack.Top < 0) || (stack.Count < 2))
+      {
+        item = default(E);
+        return false;
+      }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack, interpreter.IntegerStack);
-        }
+      var index = (int)integerStack.Pop();
+      item = stack.ReverseElementAt(index);
+
+      return true;
+    }
+  }
+
+  public class IntegerYankDuplicateExpression : YankDuplicateExpression<long>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "INTEGER.YANKDUP";
     }
 
-    public class NameYankDuplicateExpression : YankDuplicateExpression<string>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "NAME.YANKDUP"; }
+      this.Eval(interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.NameStack, interpreter.IntegerStack);
-        }
+  public class FloatYankDuplicateExpression : YankDuplicateExpression<double>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "FLOAT.YANKDUP";
     }
 
-    public class ExecYankDuplicateExpression : YankDuplicateExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "EXEC.YANKDUP"; }
+      this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.ExecStack, interpreter.IntegerStack);
-        }
+  public class BooleanYankDuplicateExpression : YankDuplicateExpression<bool>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "BOOLEAN.YANKDUP";
     }
 
-    public class CodeYankDuplicateExpression : YankDuplicateExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "CODE.YANKDUP"; }
+      this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.CodeStack, interpreter.IntegerStack);
-        }
+  public class NameYankDuplicateExpression : YankDuplicateExpression<string>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "NAME.YANKDUP";
     }
+
+    public override void Eval(IPushGpInterpreter interpreter)
+    {
+      this.Eval(interpreter.NameStack, interpreter.IntegerStack);
+    }
+  }
+
+  public class ExecYankDuplicateExpression : YankDuplicateExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "EXEC.YANKDUP";
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter)
+    {
+      this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
+    }
+  }
+
+  public class CodeYankDuplicateExpression : YankDuplicateExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "CODE.YANKDUP";
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter)
+    {
+      this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankExpressions.cs	(revision 14513)
@@ -1,89 +1,103 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    /// <summary>
-    /// Removes an indexed item from "deep" in the stack and pushes it on top of the stack.
-    /// The index is taken from the INTEGER stack, and the indexing is done after the index is removed.
-    /// </summary>
-    /// <typeparam name="T">Stacktype</typeparam>
-    public abstract class YankExpression<T> : StatelessExpression
+  /// <summary>
+  ///     Removes an indexed item from "deep" in the stack and pushes it on top of the stack.
+  ///     The index is taken from the INTEGER stack, and the indexing is done after the index is removed.
+  /// </summary>
+  /// <typeparam name="T">Stacktype</typeparam>
+  public abstract class YankExpression<T> : StatelessExpression
+  {
+    public void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1)
     {
-        public void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1)
-        {
-            if (integerStack.Count == 0)
-                return;
+      if (integerStack.Count == 0) return;
 
-            var index = integerStack.Top;
+      var index = integerStack.Top;
 
-            if (index > stack.Count - count ||
-                index < 0 ||
-                stack.Count < 2)
-                return;
+      if ((index > stack.Count - count) || (index < 0) || (stack.Count < 2)) return;
 
-            integerStack.Pop();
-            stack.Yank((int)index);
-        }
+      integerStack.Pop();
+      stack.Yank((int)index);
+    }
+  }
+
+  public class IntegerYankExpression : YankExpression<long>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "INTEGER.YANK";
     }
 
-    public class IntegerYankExpression : YankExpression<long>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "INTEGER.YANK"; }
+      this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
-        }
+  public class FloatYankExpression : YankExpression<double>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "FLOAT.YANK";
     }
 
-    public class FloatYankExpression : YankExpression<double>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "FLOAT.YANK"; }
+      this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.FloatStack, interpreter.IntegerStack);
-        }
+  public class BooleanYankExpression : YankExpression<bool>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "BOOLEAN.YANK";
     }
 
-    public class BooleanYankExpression : YankExpression<bool>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "BOOLEAN.YANK"; }
+      this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack, interpreter.IntegerStack);
-        }
+  public class NameYankExpression : YankExpression<string>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "NAME.YANK";
     }
 
-    public class NameYankExpression : YankExpression<string>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "NAME.YANK"; }
+      this.Eval(interpreter.NameStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.NameStack, interpreter.IntegerStack);
-        }
+  public class ExecYankExpression : YankExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "EXEC.YANK";
     }
 
-    public class ExecYankExpression : YankExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "EXEC.YANK"; }
+      this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.ExecStack, interpreter.IntegerStack);
-        }
+  public class CodeYankExpression : YankExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "CODE.YANK";
     }
 
-    public class CodeYankExpression : YankExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "CODE.YANK"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.CodeStack, interpreter.IntegerStack);
-        }
+      this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/BooleanGenerator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/BooleanGenerator.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/BooleanGenerator.cs	(revision 14513)
@@ -1,15 +1,14 @@
-﻿using HeuristicLab.Core;
-using HeuristicLab.Random;
+﻿namespace HeuristicLab.Algorithms.PushGP.Generators {
+  using System.Threading;
 
-namespace HeuristicLab.Algorithms.PushGP.Generators
-{
-    public static class BooleanGenerator
-    {
-        private static IRandom rand = new FastRandom();
+  using HeuristicLab.Algorithms.PushGP.Data.Random;
+  using HeuristicLab.Core;
 
-        public static bool RandomBoolean()
-        {
-            return rand.NextDouble() > 0.5 ? true : false;
-        }
+  public static class BooleanGenerator {
+    private static readonly ThreadLocal<IRandom> rand = RandomFactory.GetRandom();
+
+    public static bool RandomBoolean() {
+      return rand.Value.NextDouble() > 0.5;
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/CodeGenerator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/CodeGenerator.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/CodeGenerator.cs	(revision 14513)
@@ -1,78 +1,66 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using HeuristicLab.Algorithms.PushGP.Expressions;
-using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Core;
-using HeuristicLab.Random;
+﻿namespace HeuristicLab.Algorithms.PushGP.Generators {
+  using System;
+  using System.Collections.Generic;
+  using System.Linq;
+  using System.Threading;
 
-namespace HeuristicLab.Algorithms.PushGP.Generators
-{
+  using HeuristicLab.Algorithms.PushGP.Data.Random;
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Core;
+  using HeuristicLab.Random;
+
+  /// <summary>
+  ///     The following is the standard Push random code generation algorithm, which is used for the CODE.RAND instruction.
+  ///     It may also be useful for the initialization of programs in evolutionary computation systems, and it is used for
+  ///     this purpose in PushGP.
+  ///     It produces a uniform distribution of sizes and what seems to be a reasonable distribution of shapes, in a
+  ///     reasonable amount of time.
+  /// </summary>
+  /// <see cref="http://faculty.hampshire.edu/lspector/push3-description.html#RandomCode" />
+  public static class CodeGenerator {
+    private static readonly ThreadLocal<IRandom> random = RandomFactory.GetRandom();
+
     /// <summary>
-    /// The following is the standard Push random code generation algorithm, which is used for the CODE.RAND instruction.
-    /// It may also be useful for the initialization of programs in evolutionary computation systems, and it is used for this purpose in PushGP.
-    /// It produces a uniform distribution of sizes and what seems to be a reasonable distribution of shapes, in a reasonable amount of time.
+    ///     Generates a random program with a given max size
     /// </summary>
-    /// <see cref="http://faculty.hampshire.edu/lspector/push3-description.html#RandomCode"/>
-    public class CodeGenerator
-    {
-        private static IRandom random = new FastRandom();
-        private readonly IInterpreter interpreter;
+    /// <param name="maxPoints"></param>
+    /// <returns>Returns an ExpandExpression if maxPoints smaller or equal to Configuration.MaxProgramPoints and Noop otherwise</returns>
+    public static ExecExpandExpression RandomProgram(int maxPoints, IDictionary<string, Expression> customExpressions = null) {
+      var code = RandomCode(maxPoints, customExpressions).ToArray();
 
-        public CodeGenerator(IInterpreter interpreter)
-        {
-            this.interpreter = interpreter;
-        }
+      return new ExecExpandExpression(code);
+    }
 
-        /// <summary>
-        /// Generates a random program with a given max size
-        /// </summary>
-        /// <param name="maxPoints"></param>
-        /// <returns>Returns an ExpandExpression if maxPoints smaller or equal to Configuration.MaxProgramPoints and Noop otherwise</returns>
-        public Expression RandomProgram(int maxPoints)
-        {
-            return ExecExpandExpression.TryCreate(interpreter.CodeGenerator.RandomCode(maxPoints).ToArray(), interpreter.Configuration);
-        }
+    public static IEnumerable<Expression> RandomCode(int maxPoints, IDictionary<string, Expression> customExpressions = null) {
+      var actualPoints = random.Value.Next(1, Math.Max(1, maxPoints));
 
-        public IEnumerable<Expression> RandomCode(int maxPoints)
-        {
-            var actualPoints = random.Next(1, Math.Max(1, maxPoints));
+      return RandomCodeWithSize(actualPoints, customExpressions);
+    }
 
-            return RandomCodeWithSize(actualPoints);
-        }
+    private static IEnumerable<Expression> RandomCodeWithSize(
+      int points,
+      IDictionary<string, Expression> customExpressions = null) {
+      if (points == 1) {
+        var customCount = customExpressions == null ? 0 : customExpressions.Count - 1;
+        var index = random.Value.Next(0, ExpressionTable.Count + customCount - 1);
+        return new[] { CreateExpression(index, customExpressions) };
+      }
 
-        private IEnumerable<Expression> RandomCodeWithSize(int points)
-        {
-            if (points == 1)
-            {
-                var index = random.Next(0, ExpressionTable.Count + interpreter.CustomExpressions.Count - 2);
-                return new[] { CreateExpression(index) };
-            }
-            else
-            {
-                var sizesThisLevel = Decompose(points - 1, points - 1);
-                return sizesThisLevel.SelectMany(size => RandomCodeWithSize(size)).Shuffle(random);
-            }
-        }
+      var sizesThisLevel = Decompose(points - 1, points - 1);
+      return sizesThisLevel.SelectMany(size => RandomCodeWithSize(size, customExpressions)).Shuffle(random.Value);
+    }
 
-        private IEnumerable<int> Decompose(int number, int maxParts)
-        {
-            if (number == 1 || maxParts == 1)
-            {
-                return new[] { number };
-            }
-            else
-            {
-                var thisPart = random.Next(1, number - 1);
-                return new[] { thisPart }.Concat(Decompose(number - thisPart, maxParts - 1));
-            }
-        }
+    private static IEnumerable<int> Decompose(int number, int maxParts) {
+      if ((number == 1) || (maxParts == 1)) return new[] { number };
+      var thisPart = random.Value.Next(1, number - 1);
+      return new[] { thisPart }.Concat(Decompose(number - thisPart, maxParts - 1));
+    }
 
-        private Expression CreateExpression(int index)
-        {
-            return (index >= 0 && index < ExpressionTable.Count)
-                ? ExpressionTable.GetExpression(index)
-                : new NameDefineXExecExpression(interpreter.CustomExpressions.ElementAt(index - (ExpressionTable.Count - 1)).Key);
-        }
+    private static Expression CreateExpression(int index, IDictionary<string, Expression> customExpressions = null) {
+      if ((index >= 0) && (index < ExpressionTable.Count)) return ExpressionTable.GetExpression(index);
+
+      if (customExpressions == null) throw new IndexOutOfRangeException();
+      return new NameDefineXExecExpression(customExpressions.ElementAt(index - (ExpressionTable.Count - 1)).Key);
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/FloatGenerator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/FloatGenerator.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/FloatGenerator.cs	(revision 14513)
@@ -1,15 +1,14 @@
-﻿using HeuristicLab.Core;
-using HeuristicLab.Random;
+﻿namespace HeuristicLab.Algorithms.PushGP.Generators {
+  using System.Threading;
 
-namespace HeuristicLab.Algorithms.PushGP.Generators
-{
-    public class FloatGenerator
-    {
-        private static IRandom rand = new FastRandom();
+  using HeuristicLab.Algorithms.PushGP.Data.Random;
+  using HeuristicLab.Core;
 
-        public static double RandomFloat(double min = double.MinValue, double max = double.MaxValue)
-        {
-            return rand.NextDouble() * (max - min) + min;
-        }
+  public class FloatGenerator {
+    private static readonly ThreadLocal<IRandom> rand = RandomFactory.GetRandom();
+
+    public static double RandomFloat(double min = double.MinValue, double max = double.MaxValue) {
+      return rand.Value.NextDouble() * (max - min) + min;
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/IntegerGenerator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/IntegerGenerator.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/IntegerGenerator.cs	(revision 14513)
@@ -1,15 +1,14 @@
-﻿using HeuristicLab.Core;
-using HeuristicLab.Random;
+﻿namespace HeuristicLab.Algorithms.PushGP.Generators {
+  using System.Threading;
 
-namespace HeuristicLab.Algorithms.PushGP.Generators
-{
-    public static class IntegerGenerator
-    {
-        private static IRandom rand = new FastRandom();
+  using HeuristicLab.Algorithms.PushGP.Data.Random;
+  using HeuristicLab.Core;
 
-        public static long RandomInteger(int min = int.MinValue, int max = int.MaxValue)
-        {
-            return rand.Next(min, max);
-        }
+  public static class IntegerGenerator {
+    private static readonly ThreadLocal<IRandom> rand = RandomFactory.GetRandom();
+
+    public static long RandomInteger(int min = int.MinValue, int max = int.MaxValue) {
+      return rand.Value.Next(min, max);
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/NameGenerator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/NameGenerator.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/NameGenerator.cs	(revision 14513)
@@ -1,47 +1,44 @@
-﻿using System;
-using HeuristicLab.Core;
-using HeuristicLab.Random;
+﻿namespace HeuristicLab.Algorithms.PushGP.Generators {
+  using System;
+  using System.Threading;
 
-namespace HeuristicLab.Algorithms.PushGP.Generators
-{
-    public class NameGenerator
-    {
-        public const int DefaultRandomNameLength = 10;
-        private static IRandom rand = new FastRandom();
-        private static char[] chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890".ToCharArray();
+  using HeuristicLab.Algorithms.PushGP.Data.Random;
+  using HeuristicLab.Core;
 
-        private int index = 0;
+  public class NameGenerator {
+    public const int DefaultRandomNameLength = 10;
 
-        public string GetNextString()
-        {
-            var length = index < chars.Length ? 1 : (int)(Math.Log(index, chars.Length)) + 1;
-            var result = new char[length];
-            var tmp = index;
-            index++;
+    private static readonly ThreadLocal<IRandom> rand = RandomFactory.GetRandom();
 
-            for (var i = length; i > 0; i--)
-            {
-                var a = (int)Math.Pow(chars.Length, i - 1);
-                var b = tmp / a;
+    private static readonly char[] chars =
+      "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890".ToCharArray();
 
-                result[length - i] = chars[b];
+    private int index;
 
-                tmp -= a * b;
-            }
+    public string GetNextString() {
+      var length = this.index < chars.Length ? 1 : (int)Math.Log(this.index, chars.Length) + 1;
+      var result = new char[length];
+      var tmp = this.index;
+      this.index++;
 
-            return new string(result);
-        }
+      for (var i = length; i > 0; i--) {
+        var a = (int)Math.Pow(chars.Length, i - 1);
+        var b = tmp / a;
 
-        public static string RandomName(int length = DefaultRandomNameLength)
-        {
-            var name = new char[length];
+        result[length - i] = chars[b];
 
-            for (var i = 0; i < length; i++)
-            {
-                name[i] = chars[rand.Next(chars.Length)];
-            }
+        tmp -= a * b;
+      }
 
-            return new string(name);
-        }
+      return new string(result);
     }
+
+    public static string RandomName(int length = DefaultRandomNameLength) {
+      var name = new char[length];
+
+      for (var i = 0; i < length; i++) name[i] = chars[rand.Value.Next(chars.Length)];
+
+      return new string(name);
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj	(revision 14513)
@@ -22,4 +22,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <LangVersion>5</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -52,6 +53,9 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Data\ExpressionNode.cs" />
-    <Compile Include="Data\ExpressionTree.cs" />
+    <Compile Include="Data\Pool\IRecyclable.cs" />
+    <Compile Include="Data\Pool\ObjectPool.cs" />
+    <Compile Include="Data\Random\RandomFactory.cs" />
+    <Compile Include="Data\Tree\ExpressionNode.cs" />
+    <Compile Include="Data\Tree\ExpressionTree.cs" />
     <Compile Include="Exporter\Exporter.cs" />
     <Compile Include="Expressions\BooleanExpressions.cs" />
@@ -83,4 +87,6 @@
     <Compile Include="Expressions\Expression.cs" />
     <Compile Include="Expressions\NameExpressions.cs" />
+    <Compile Include="Interpreter\PooledPushGpInterpreter.cs" />
+    <Compile Include="Interpreter\PushGpInterpreterPool.cs" />
     <Compile Include="Simplifier\ISimplifier.cs" />
     <Compile Include="Simplifier\RandomSimplifier.cs" />
@@ -91,11 +97,11 @@
     <Compile Include="Interpreter\Configuration.cs" />
     <Compile Include="Generators\CodeGenerator.cs" />
-    <Compile Include="Parser\Parser.cs" />
+    <Compile Include="Parser\PushGPParser.cs" />
     <Compile Include="Stack\IStack.cs" />
     <Compile Include="Interpreter\PushGPInterpreter.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="Interpreter\IInterpreter.cs" />
+    <Compile Include="Interpreter\IPushGpInterpreter.cs" />
     <Compile Include="Stack\PushGPStack.cs" />
-    <Compile Include="ExpressionTable.cs" />
+    <Compile Include="Expressions\ExpressionTable.cs" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj.user
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj.user	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj.user	(revision 14513)
@@ -2,5 +2,5 @@
 <Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <PropertyGroup>
-    <ProjectView>ProjectFiles</ProjectView>
+    <ProjectView>ShowAllFiles</ProjectView>
   </PropertyGroup>
 </Project>
